#include "DatabaseHandler/DatabaseHandler.h"
#include "DatabaseHandler/Source/v2/DataClasses/TeamSeasonStatistics.h"
#include "DatabaseHandlerTests/InMemoryDbFixture.h"

TEST_F(InMemoryDbFixture, TeamSeasonStatisticsTests)
{
	using namespace database_handler;
	using namespace database_handler::v2;
	using namespace database_handler::common;
	
	TeamSeasonStatistics teamSeasonStatistics1;
	teamSeasonStatistics1.sm_team_id = 1;
	teamSeasonStatistics1.sm_season_id = 2;
	teamSeasonStatistics1.sm_stage_id = 3;
	teamSeasonStatistics1.home_wins = 4;
	teamSeasonStatistics1.away_wins = 5;
	teamSeasonStatistics1.home_draws = 6;
	teamSeasonStatistics1.away_draws = 7;
	teamSeasonStatistics1.home_losses = 8;
	teamSeasonStatistics1.away_losses = 9;
	teamSeasonStatistics1.home_goals_for = 10;
	teamSeasonStatistics1.away_goals_for = 11;
	teamSeasonStatistics1.home_goals_against = 12;
	teamSeasonStatistics1.away_goals_against = 13;
	teamSeasonStatistics1.home_clean_sheet = 14;
	teamSeasonStatistics1.away_clean_sheet = 15;
	teamSeasonStatistics1.home_failed_to_score = 16;
	teamSeasonStatistics1.away_failed_to_score = 17;
	teamSeasonStatistics1.home_avg_goals_per_game_scored_opt = 18.19;
	teamSeasonStatistics1.away_avg_goals_per_game_scored_opt = 20.21;
	teamSeasonStatistics1.home_avg_goals_per_game_conceded_opt = 22.23;
	teamSeasonStatistics1.away_avg_goals_per_game_conceded_opt = 24.25;
	teamSeasonStatistics1.home_avg_first_goal_scored = STR("home_avg_first_goal_scored26");
	teamSeasonStatistics1.away_avg_first_goal_scored = STR("away_avg_first_goal_scored27");
	teamSeasonStatistics1.overall_avg_first_goal_scored = STR("overall_avg_first_goal_scored28");
	teamSeasonStatistics1.home_avg_first_goal_conceded = STR("home_avg_first_goal_conceded29");
	teamSeasonStatistics1.away_avg_first_goal_conceded = STR("away_avg_first_goal_conceded30");
	teamSeasonStatistics1.overall_avg_first_goal_conceded = STR("overall_avg_first_goal_conceded31");
	teamSeasonStatistics1.attacks_opt = 32;
	teamSeasonStatistics1.dangerous_attacks_opt = 33;
	teamSeasonStatistics1.avg_ball_possession_percentage_opt = 34.35;
	teamSeasonStatistics1.fouls_opt = 36;
	teamSeasonStatistics1.avg_fouls_per_game_opt = 37.38;
	teamSeasonStatistics1.offsides_opt = 39;
	teamSeasonStatistics1.redcards_opt = 40;
	teamSeasonStatistics1.yellowcards_opt = 41;
	teamSeasonStatistics1.shots_blocked_opt = 42;
	teamSeasonStatistics1.shots_off_target_opt = 43;
	teamSeasonStatistics1.avg_shots_off_target_per_game_opt = 44.45;
	teamSeasonStatistics1.shots_on_target_opt = 46;
	teamSeasonStatistics1.avg_shots_on_target_per_game_opt = 47.48;
	teamSeasonStatistics1.avg_corners_opt = 49.50;
	teamSeasonStatistics1.total_corners_opt = 51;
	teamSeasonStatistics1.btts_opt = 52.53;
	
	TeamSeasonStatistics teamSeasonStatistics2;
	
	TeamSeasonStatistics teamSeasonStatistics3;
	teamSeasonStatistics3.sm_team_id = 54;
	teamSeasonStatistics3.sm_season_id = 55;
	teamSeasonStatistics3.sm_stage_id = 56;
	teamSeasonStatistics3.home_wins = 57;
	teamSeasonStatistics3.away_wins = 58;
	teamSeasonStatistics3.home_draws = 59;
	teamSeasonStatistics3.away_draws = 60;
	teamSeasonStatistics3.home_losses = 61;
	teamSeasonStatistics3.away_losses = 62;
	teamSeasonStatistics3.home_goals_for = 63;
	teamSeasonStatistics3.away_goals_for = 64;
	teamSeasonStatistics3.home_goals_against = 65;
	teamSeasonStatistics3.away_goals_against = 66;
	teamSeasonStatistics3.home_clean_sheet = 67;
	teamSeasonStatistics3.away_clean_sheet = 68;
	teamSeasonStatistics3.home_failed_to_score = 69;
	teamSeasonStatistics3.away_failed_to_score = 70;
	teamSeasonStatistics3.home_avg_goals_per_game_scored_opt = 71.72;
	teamSeasonStatistics3.away_avg_goals_per_game_scored_opt = 73.74;
	teamSeasonStatistics3.home_avg_goals_per_game_conceded_opt = 75.76;
	teamSeasonStatistics3.away_avg_goals_per_game_conceded_opt = 77.78;
	teamSeasonStatistics3.home_avg_first_goal_scored = STR("home_avg_first_goal_scored79");
	teamSeasonStatistics3.away_avg_first_goal_scored = STR("away_avg_first_goal_scored80");
	teamSeasonStatistics3.overall_avg_first_goal_scored = STR("overall_avg_first_goal_scored81");
	teamSeasonStatistics3.home_avg_first_goal_conceded = STR("home_avg_first_goal_conceded82");
	teamSeasonStatistics3.away_avg_first_goal_conceded = STR("away_avg_first_goal_conceded83");
	teamSeasonStatistics3.overall_avg_first_goal_conceded = STR("overall_avg_first_goal_conceded84");
	teamSeasonStatistics3.attacks_opt = 85;
	teamSeasonStatistics3.dangerous_attacks_opt = 86;
	teamSeasonStatistics3.avg_ball_possession_percentage_opt = 87.88;
	teamSeasonStatistics3.fouls_opt = 89;
	teamSeasonStatistics3.avg_fouls_per_game_opt = 90.91;
	teamSeasonStatistics3.offsides_opt = 92;
	teamSeasonStatistics3.redcards_opt = 93;
	teamSeasonStatistics3.yellowcards_opt = 94;
	teamSeasonStatistics3.shots_blocked_opt = 95;
	teamSeasonStatistics3.shots_off_target_opt = 96;
	teamSeasonStatistics3.avg_shots_off_target_per_game_opt = 97.98;
	teamSeasonStatistics3.shots_on_target_opt = 99;
	teamSeasonStatistics3.avg_shots_on_target_per_game_opt = 100.101;
	teamSeasonStatistics3.avg_corners_opt = 102.103;
	teamSeasonStatistics3.total_corners_opt = 104;
	teamSeasonStatistics3.btts_opt = 105.106;
	
	std::vector<UpTeamSeasonStatistics> oneTeamSeasonStatistics;
	oneTeamSeasonStatistics.emplace_back(std::make_unique<TeamSeasonStatistics>(teamSeasonStatistics1));

	std::vector<UpTeamSeasonStatistics> twoteamSeasonStatistics;
	twoteamSeasonStatistics.emplace_back(std::make_unique<TeamSeasonStatistics>(teamSeasonStatistics1));
	twoteamSeasonStatistics.emplace_back(std::make_unique<TeamSeasonStatistics>(teamSeasonStatistics2));

	std::vector<UpTeamSeasonStatistics> threeteamSeasonStatistics;
	threeteamSeasonStatistics.emplace_back(std::make_unique<TeamSeasonStatistics>(teamSeasonStatistics1));
	threeteamSeasonStatistics.emplace_back(std::make_unique<TeamSeasonStatistics>(teamSeasonStatistics2));
	threeteamSeasonStatistics.emplace_back(std::make_unique<TeamSeasonStatistics>(teamSeasonStatistics3));

	EXPECT_EQ(1, oneTeamSeasonStatistics.size());
	EXPECT_EQ(2, twoteamSeasonStatistics.size());
	EXPECT_EQ(3, threeteamSeasonStatistics.size());

	ASSERT_NO_THROW(db.exec(CREATE_TABLE_TEAM_SEASON_STATISTICS));
	ASSERT_NO_THROW(InsertOr(OnConflict::Ignore, db, oneTeamSeasonStatistics));
	ASSERT_EQ(1, QueryCount<TeamSeasonStatistics>(db));
	{
		auto teamSeasonStatistics = QueryAll<TeamSeasonStatistics>(db);
		EXPECT_EQ(1, teamSeasonStatistics.size());

		EXPECT_NE(0, teamSeasonStatistics[0]->id);
		EXPECT_EQ(teamSeasonStatistics1.sm_team_id, teamSeasonStatistics[0]->sm_team_id);
		EXPECT_EQ(teamSeasonStatistics1.sm_season_id, teamSeasonStatistics[0]->sm_season_id);
		EXPECT_EQ(teamSeasonStatistics1.sm_stage_id, teamSeasonStatistics[0]->sm_stage_id);
		EXPECT_EQ(teamSeasonStatistics1.home_wins, teamSeasonStatistics[0]->home_wins);
		EXPECT_EQ(teamSeasonStatistics1.away_wins, teamSeasonStatistics[0]->away_wins);
		EXPECT_EQ(teamSeasonStatistics1.home_draws, teamSeasonStatistics[0]->home_draws);
		EXPECT_EQ(teamSeasonStatistics1.away_draws, teamSeasonStatistics[0]->away_draws);
		EXPECT_EQ(teamSeasonStatistics1.home_losses, teamSeasonStatistics[0]->home_losses);
		EXPECT_EQ(teamSeasonStatistics1.away_losses, teamSeasonStatistics[0]->away_losses);
		EXPECT_EQ(teamSeasonStatistics1.home_goals_for, teamSeasonStatistics[0]->home_goals_for);
		EXPECT_EQ(teamSeasonStatistics1.away_goals_for, teamSeasonStatistics[0]->away_goals_for);
		EXPECT_EQ(teamSeasonStatistics1.home_goals_against, teamSeasonStatistics[0]->home_goals_against);
		EXPECT_EQ(teamSeasonStatistics1.away_goals_against, teamSeasonStatistics[0]->away_goals_against);
		EXPECT_EQ(teamSeasonStatistics1.home_clean_sheet, teamSeasonStatistics[0]->home_clean_sheet);
		EXPECT_EQ(teamSeasonStatistics1.away_clean_sheet, teamSeasonStatistics[0]->away_clean_sheet);
		EXPECT_EQ(teamSeasonStatistics1.home_failed_to_score, teamSeasonStatistics[0]->home_failed_to_score);
		EXPECT_EQ(teamSeasonStatistics1.away_failed_to_score, teamSeasonStatistics[0]->away_failed_to_score);
		EXPECT_EQ(teamSeasonStatistics1.home_avg_goals_per_game_scored_opt, teamSeasonStatistics[0]->home_avg_goals_per_game_scored_opt);
		EXPECT_EQ(teamSeasonStatistics1.away_avg_goals_per_game_scored_opt, teamSeasonStatistics[0]->away_avg_goals_per_game_scored_opt);
		EXPECT_EQ(teamSeasonStatistics1.home_avg_goals_per_game_conceded_opt, teamSeasonStatistics[0]->home_avg_goals_per_game_conceded_opt);
		EXPECT_EQ(teamSeasonStatistics1.away_avg_goals_per_game_conceded_opt, teamSeasonStatistics[0]->away_avg_goals_per_game_conceded_opt);
		EXPECT_EQ(teamSeasonStatistics1.home_avg_first_goal_scored, teamSeasonStatistics[0]->home_avg_first_goal_scored);
		EXPECT_EQ(teamSeasonStatistics1.away_avg_first_goal_scored, teamSeasonStatistics[0]->away_avg_first_goal_scored);
		EXPECT_EQ(teamSeasonStatistics1.overall_avg_first_goal_scored, teamSeasonStatistics[0]->overall_avg_first_goal_scored);
		EXPECT_EQ(teamSeasonStatistics1.home_avg_first_goal_conceded, teamSeasonStatistics[0]->home_avg_first_goal_conceded);
		EXPECT_EQ(teamSeasonStatistics1.away_avg_first_goal_conceded, teamSeasonStatistics[0]->away_avg_first_goal_conceded);
		EXPECT_EQ(teamSeasonStatistics1.overall_avg_first_goal_conceded, teamSeasonStatistics[0]->overall_avg_first_goal_conceded);
		EXPECT_EQ(teamSeasonStatistics1.attacks_opt, teamSeasonStatistics[0]->attacks_opt);
		EXPECT_EQ(teamSeasonStatistics1.dangerous_attacks_opt, teamSeasonStatistics[0]->dangerous_attacks_opt);
		EXPECT_EQ(teamSeasonStatistics1.avg_ball_possession_percentage_opt, teamSeasonStatistics[0]->avg_ball_possession_percentage_opt);
		EXPECT_EQ(teamSeasonStatistics1.fouls_opt, teamSeasonStatistics[0]->fouls_opt);
		EXPECT_EQ(teamSeasonStatistics1.avg_fouls_per_game_opt, teamSeasonStatistics[0]->avg_fouls_per_game_opt);
		EXPECT_EQ(teamSeasonStatistics1.offsides_opt, teamSeasonStatistics[0]->offsides_opt);
		EXPECT_EQ(teamSeasonStatistics1.redcards_opt, teamSeasonStatistics[0]->redcards_opt);
		EXPECT_EQ(teamSeasonStatistics1.yellowcards_opt, teamSeasonStatistics[0]->yellowcards_opt);
		EXPECT_EQ(teamSeasonStatistics1.shots_blocked_opt, teamSeasonStatistics[0]->shots_blocked_opt);
		EXPECT_EQ(teamSeasonStatistics1.shots_off_target_opt, teamSeasonStatistics[0]->shots_off_target_opt);
		EXPECT_EQ(teamSeasonStatistics1.avg_shots_off_target_per_game_opt, teamSeasonStatistics[0]->avg_shots_off_target_per_game_opt);
		EXPECT_EQ(teamSeasonStatistics1.shots_on_target_opt, teamSeasonStatistics[0]->shots_on_target_opt);
		EXPECT_EQ(teamSeasonStatistics1.avg_shots_on_target_per_game_opt, teamSeasonStatistics[0]->avg_shots_on_target_per_game_opt);
		EXPECT_EQ(teamSeasonStatistics1.avg_corners_opt, teamSeasonStatistics[0]->avg_corners_opt);
		EXPECT_EQ(teamSeasonStatistics1.total_corners_opt, teamSeasonStatistics[0]->total_corners_opt);
		EXPECT_EQ(teamSeasonStatistics1.btts_opt, teamSeasonStatistics[0]->btts_opt);
		
	}
	ASSERT_NO_THROW(InsertOr(OnConflict::Ignore, db, twoteamSeasonStatistics));
	ASSERT_EQ(2, QueryCount<TeamSeasonStatistics>(db));
	{
		auto teamSeasonStatistics = QueryAll<TeamSeasonStatistics>(db);
		EXPECT_EQ(2, teamSeasonStatistics.size());

		EXPECT_NE(0, teamSeasonStatistics[0]->id);
		EXPECT_EQ(teamSeasonStatistics1.sm_team_id, teamSeasonStatistics[0]->sm_team_id);
		EXPECT_EQ(teamSeasonStatistics1.sm_season_id, teamSeasonStatistics[0]->sm_season_id);
		EXPECT_EQ(teamSeasonStatistics1.sm_stage_id, teamSeasonStatistics[0]->sm_stage_id);
		EXPECT_EQ(teamSeasonStatistics1.home_wins, teamSeasonStatistics[0]->home_wins);
		EXPECT_EQ(teamSeasonStatistics1.away_wins, teamSeasonStatistics[0]->away_wins);
		EXPECT_EQ(teamSeasonStatistics1.home_draws, teamSeasonStatistics[0]->home_draws);
		EXPECT_EQ(teamSeasonStatistics1.away_draws, teamSeasonStatistics[0]->away_draws);
		EXPECT_EQ(teamSeasonStatistics1.home_losses, teamSeasonStatistics[0]->home_losses);
		EXPECT_EQ(teamSeasonStatistics1.away_losses, teamSeasonStatistics[0]->away_losses);
		EXPECT_EQ(teamSeasonStatistics1.home_goals_for, teamSeasonStatistics[0]->home_goals_for);
		EXPECT_EQ(teamSeasonStatistics1.away_goals_for, teamSeasonStatistics[0]->away_goals_for);
		EXPECT_EQ(teamSeasonStatistics1.home_goals_against, teamSeasonStatistics[0]->home_goals_against);
		EXPECT_EQ(teamSeasonStatistics1.away_goals_against, teamSeasonStatistics[0]->away_goals_against);
		EXPECT_EQ(teamSeasonStatistics1.home_clean_sheet, teamSeasonStatistics[0]->home_clean_sheet);
		EXPECT_EQ(teamSeasonStatistics1.away_clean_sheet, teamSeasonStatistics[0]->away_clean_sheet);
		EXPECT_EQ(teamSeasonStatistics1.home_failed_to_score, teamSeasonStatistics[0]->home_failed_to_score);
		EXPECT_EQ(teamSeasonStatistics1.away_failed_to_score, teamSeasonStatistics[0]->away_failed_to_score);
		EXPECT_EQ(teamSeasonStatistics1.home_avg_goals_per_game_scored_opt, teamSeasonStatistics[0]->home_avg_goals_per_game_scored_opt);
		EXPECT_EQ(teamSeasonStatistics1.away_avg_goals_per_game_scored_opt, teamSeasonStatistics[0]->away_avg_goals_per_game_scored_opt);
		EXPECT_EQ(teamSeasonStatistics1.home_avg_goals_per_game_conceded_opt, teamSeasonStatistics[0]->home_avg_goals_per_game_conceded_opt);
		EXPECT_EQ(teamSeasonStatistics1.away_avg_goals_per_game_conceded_opt, teamSeasonStatistics[0]->away_avg_goals_per_game_conceded_opt);
		EXPECT_EQ(teamSeasonStatistics1.home_avg_first_goal_scored, teamSeasonStatistics[0]->home_avg_first_goal_scored);
		EXPECT_EQ(teamSeasonStatistics1.away_avg_first_goal_scored, teamSeasonStatistics[0]->away_avg_first_goal_scored);
		EXPECT_EQ(teamSeasonStatistics1.overall_avg_first_goal_scored, teamSeasonStatistics[0]->overall_avg_first_goal_scored);
		EXPECT_EQ(teamSeasonStatistics1.home_avg_first_goal_conceded, teamSeasonStatistics[0]->home_avg_first_goal_conceded);
		EXPECT_EQ(teamSeasonStatistics1.away_avg_first_goal_conceded, teamSeasonStatistics[0]->away_avg_first_goal_conceded);
		EXPECT_EQ(teamSeasonStatistics1.overall_avg_first_goal_conceded, teamSeasonStatistics[0]->overall_avg_first_goal_conceded);
		EXPECT_EQ(teamSeasonStatistics1.attacks_opt, teamSeasonStatistics[0]->attacks_opt);
		EXPECT_EQ(teamSeasonStatistics1.dangerous_attacks_opt, teamSeasonStatistics[0]->dangerous_attacks_opt);
		EXPECT_EQ(teamSeasonStatistics1.avg_ball_possession_percentage_opt, teamSeasonStatistics[0]->avg_ball_possession_percentage_opt);
		EXPECT_EQ(teamSeasonStatistics1.fouls_opt, teamSeasonStatistics[0]->fouls_opt);
		EXPECT_EQ(teamSeasonStatistics1.avg_fouls_per_game_opt, teamSeasonStatistics[0]->avg_fouls_per_game_opt);
		EXPECT_EQ(teamSeasonStatistics1.offsides_opt, teamSeasonStatistics[0]->offsides_opt);
		EXPECT_EQ(teamSeasonStatistics1.redcards_opt, teamSeasonStatistics[0]->redcards_opt);
		EXPECT_EQ(teamSeasonStatistics1.yellowcards_opt, teamSeasonStatistics[0]->yellowcards_opt);
		EXPECT_EQ(teamSeasonStatistics1.shots_blocked_opt, teamSeasonStatistics[0]->shots_blocked_opt);
		EXPECT_EQ(teamSeasonStatistics1.shots_off_target_opt, teamSeasonStatistics[0]->shots_off_target_opt);
		EXPECT_EQ(teamSeasonStatistics1.avg_shots_off_target_per_game_opt, teamSeasonStatistics[0]->avg_shots_off_target_per_game_opt);
		EXPECT_EQ(teamSeasonStatistics1.shots_on_target_opt, teamSeasonStatistics[0]->shots_on_target_opt);
		EXPECT_EQ(teamSeasonStatistics1.avg_shots_on_target_per_game_opt, teamSeasonStatistics[0]->avg_shots_on_target_per_game_opt);
		EXPECT_EQ(teamSeasonStatistics1.avg_corners_opt, teamSeasonStatistics[0]->avg_corners_opt);
		EXPECT_EQ(teamSeasonStatistics1.total_corners_opt, teamSeasonStatistics[0]->total_corners_opt);
		EXPECT_EQ(teamSeasonStatistics1.btts_opt, teamSeasonStatistics[0]->btts_opt);
		

		EXPECT_NE(0, teamSeasonStatistics[1]->id);
		EXPECT_EQ(teamSeasonStatistics2.sm_team_id, teamSeasonStatistics[1]->sm_team_id);
		EXPECT_EQ(teamSeasonStatistics2.sm_season_id, teamSeasonStatistics[1]->sm_season_id);
		EXPECT_EQ(teamSeasonStatistics2.sm_stage_id, teamSeasonStatistics[1]->sm_stage_id);
		EXPECT_EQ(teamSeasonStatistics2.home_wins, teamSeasonStatistics[1]->home_wins);
		EXPECT_EQ(teamSeasonStatistics2.away_wins, teamSeasonStatistics[1]->away_wins);
		EXPECT_EQ(teamSeasonStatistics2.home_draws, teamSeasonStatistics[1]->home_draws);
		EXPECT_EQ(teamSeasonStatistics2.away_draws, teamSeasonStatistics[1]->away_draws);
		EXPECT_EQ(teamSeasonStatistics2.home_losses, teamSeasonStatistics[1]->home_losses);
		EXPECT_EQ(teamSeasonStatistics2.away_losses, teamSeasonStatistics[1]->away_losses);
		EXPECT_EQ(teamSeasonStatistics2.home_goals_for, teamSeasonStatistics[1]->home_goals_for);
		EXPECT_EQ(teamSeasonStatistics2.away_goals_for, teamSeasonStatistics[1]->away_goals_for);
		EXPECT_EQ(teamSeasonStatistics2.home_goals_against, teamSeasonStatistics[1]->home_goals_against);
		EXPECT_EQ(teamSeasonStatistics2.away_goals_against, teamSeasonStatistics[1]->away_goals_against);
		EXPECT_EQ(teamSeasonStatistics2.home_clean_sheet, teamSeasonStatistics[1]->home_clean_sheet);
		EXPECT_EQ(teamSeasonStatistics2.away_clean_sheet, teamSeasonStatistics[1]->away_clean_sheet);
		EXPECT_EQ(teamSeasonStatistics2.home_failed_to_score, teamSeasonStatistics[1]->home_failed_to_score);
		EXPECT_EQ(teamSeasonStatistics2.away_failed_to_score, teamSeasonStatistics[1]->away_failed_to_score);
		EXPECT_EQ(teamSeasonStatistics2.home_avg_goals_per_game_scored_opt, teamSeasonStatistics[1]->home_avg_goals_per_game_scored_opt);
		EXPECT_EQ(teamSeasonStatistics2.away_avg_goals_per_game_scored_opt, teamSeasonStatistics[1]->away_avg_goals_per_game_scored_opt);
		EXPECT_EQ(teamSeasonStatistics2.home_avg_goals_per_game_conceded_opt, teamSeasonStatistics[1]->home_avg_goals_per_game_conceded_opt);
		EXPECT_EQ(teamSeasonStatistics2.away_avg_goals_per_game_conceded_opt, teamSeasonStatistics[1]->away_avg_goals_per_game_conceded_opt);
		EXPECT_EQ(teamSeasonStatistics2.home_avg_first_goal_scored, teamSeasonStatistics[1]->home_avg_first_goal_scored);
		EXPECT_EQ(teamSeasonStatistics2.away_avg_first_goal_scored, teamSeasonStatistics[1]->away_avg_first_goal_scored);
		EXPECT_EQ(teamSeasonStatistics2.overall_avg_first_goal_scored, teamSeasonStatistics[1]->overall_avg_first_goal_scored);
		EXPECT_EQ(teamSeasonStatistics2.home_avg_first_goal_conceded, teamSeasonStatistics[1]->home_avg_first_goal_conceded);
		EXPECT_EQ(teamSeasonStatistics2.away_avg_first_goal_conceded, teamSeasonStatistics[1]->away_avg_first_goal_conceded);
		EXPECT_EQ(teamSeasonStatistics2.overall_avg_first_goal_conceded, teamSeasonStatistics[1]->overall_avg_first_goal_conceded);
		EXPECT_EQ(teamSeasonStatistics2.attacks_opt, teamSeasonStatistics[1]->attacks_opt);
		EXPECT_EQ(teamSeasonStatistics2.dangerous_attacks_opt, teamSeasonStatistics[1]->dangerous_attacks_opt);
		EXPECT_EQ(teamSeasonStatistics2.avg_ball_possession_percentage_opt, teamSeasonStatistics[1]->avg_ball_possession_percentage_opt);
		EXPECT_EQ(teamSeasonStatistics2.fouls_opt, teamSeasonStatistics[1]->fouls_opt);
		EXPECT_EQ(teamSeasonStatistics2.avg_fouls_per_game_opt, teamSeasonStatistics[1]->avg_fouls_per_game_opt);
		EXPECT_EQ(teamSeasonStatistics2.offsides_opt, teamSeasonStatistics[1]->offsides_opt);
		EXPECT_EQ(teamSeasonStatistics2.redcards_opt, teamSeasonStatistics[1]->redcards_opt);
		EXPECT_EQ(teamSeasonStatistics2.yellowcards_opt, teamSeasonStatistics[1]->yellowcards_opt);
		EXPECT_EQ(teamSeasonStatistics2.shots_blocked_opt, teamSeasonStatistics[1]->shots_blocked_opt);
		EXPECT_EQ(teamSeasonStatistics2.shots_off_target_opt, teamSeasonStatistics[1]->shots_off_target_opt);
		EXPECT_EQ(teamSeasonStatistics2.avg_shots_off_target_per_game_opt, teamSeasonStatistics[1]->avg_shots_off_target_per_game_opt);
		EXPECT_EQ(teamSeasonStatistics2.shots_on_target_opt, teamSeasonStatistics[1]->shots_on_target_opt);
		EXPECT_EQ(teamSeasonStatistics2.avg_shots_on_target_per_game_opt, teamSeasonStatistics[1]->avg_shots_on_target_per_game_opt);
		EXPECT_EQ(teamSeasonStatistics2.avg_corners_opt, teamSeasonStatistics[1]->avg_corners_opt);
		EXPECT_EQ(teamSeasonStatistics2.total_corners_opt, teamSeasonStatistics[1]->total_corners_opt);
		EXPECT_EQ(teamSeasonStatistics2.btts_opt, teamSeasonStatistics[1]->btts_opt);
		
	}
	ASSERT_NO_THROW(InsertOr(OnConflict::Ignore, db, threeteamSeasonStatistics));
	ASSERT_EQ(3, QueryCount<TeamSeasonStatistics>(db));
	{
		auto teamSeasonStatistics = QueryAll<TeamSeasonStatistics>(db);
		EXPECT_EQ(3, teamSeasonStatistics.size());

		EXPECT_NE(0, teamSeasonStatistics[0]->id);
		EXPECT_EQ(teamSeasonStatistics1.sm_team_id, teamSeasonStatistics[0]->sm_team_id);
		EXPECT_EQ(teamSeasonStatistics1.sm_season_id, teamSeasonStatistics[0]->sm_season_id);
		EXPECT_EQ(teamSeasonStatistics1.sm_stage_id, teamSeasonStatistics[0]->sm_stage_id);
		EXPECT_EQ(teamSeasonStatistics1.home_wins, teamSeasonStatistics[0]->home_wins);
		EXPECT_EQ(teamSeasonStatistics1.away_wins, teamSeasonStatistics[0]->away_wins);
		EXPECT_EQ(teamSeasonStatistics1.home_draws, teamSeasonStatistics[0]->home_draws);
		EXPECT_EQ(teamSeasonStatistics1.away_draws, teamSeasonStatistics[0]->away_draws);
		EXPECT_EQ(teamSeasonStatistics1.home_losses, teamSeasonStatistics[0]->home_losses);
		EXPECT_EQ(teamSeasonStatistics1.away_losses, teamSeasonStatistics[0]->away_losses);
		EXPECT_EQ(teamSeasonStatistics1.home_goals_for, teamSeasonStatistics[0]->home_goals_for);
		EXPECT_EQ(teamSeasonStatistics1.away_goals_for, teamSeasonStatistics[0]->away_goals_for);
		EXPECT_EQ(teamSeasonStatistics1.home_goals_against, teamSeasonStatistics[0]->home_goals_against);
		EXPECT_EQ(teamSeasonStatistics1.away_goals_against, teamSeasonStatistics[0]->away_goals_against);
		EXPECT_EQ(teamSeasonStatistics1.home_clean_sheet, teamSeasonStatistics[0]->home_clean_sheet);
		EXPECT_EQ(teamSeasonStatistics1.away_clean_sheet, teamSeasonStatistics[0]->away_clean_sheet);
		EXPECT_EQ(teamSeasonStatistics1.home_failed_to_score, teamSeasonStatistics[0]->home_failed_to_score);
		EXPECT_EQ(teamSeasonStatistics1.away_failed_to_score, teamSeasonStatistics[0]->away_failed_to_score);
		EXPECT_EQ(teamSeasonStatistics1.home_avg_goals_per_game_scored_opt, teamSeasonStatistics[0]->home_avg_goals_per_game_scored_opt);
		EXPECT_EQ(teamSeasonStatistics1.away_avg_goals_per_game_scored_opt, teamSeasonStatistics[0]->away_avg_goals_per_game_scored_opt);
		EXPECT_EQ(teamSeasonStatistics1.home_avg_goals_per_game_conceded_opt, teamSeasonStatistics[0]->home_avg_goals_per_game_conceded_opt);
		EXPECT_EQ(teamSeasonStatistics1.away_avg_goals_per_game_conceded_opt, teamSeasonStatistics[0]->away_avg_goals_per_game_conceded_opt);
		EXPECT_EQ(teamSeasonStatistics1.home_avg_first_goal_scored, teamSeasonStatistics[0]->home_avg_first_goal_scored);
		EXPECT_EQ(teamSeasonStatistics1.away_avg_first_goal_scored, teamSeasonStatistics[0]->away_avg_first_goal_scored);
		EXPECT_EQ(teamSeasonStatistics1.overall_avg_first_goal_scored, teamSeasonStatistics[0]->overall_avg_first_goal_scored);
		EXPECT_EQ(teamSeasonStatistics1.home_avg_first_goal_conceded, teamSeasonStatistics[0]->home_avg_first_goal_conceded);
		EXPECT_EQ(teamSeasonStatistics1.away_avg_first_goal_conceded, teamSeasonStatistics[0]->away_avg_first_goal_conceded);
		EXPECT_EQ(teamSeasonStatistics1.overall_avg_first_goal_conceded, teamSeasonStatistics[0]->overall_avg_first_goal_conceded);
		EXPECT_EQ(teamSeasonStatistics1.attacks_opt, teamSeasonStatistics[0]->attacks_opt);
		EXPECT_EQ(teamSeasonStatistics1.dangerous_attacks_opt, teamSeasonStatistics[0]->dangerous_attacks_opt);
		EXPECT_EQ(teamSeasonStatistics1.avg_ball_possession_percentage_opt, teamSeasonStatistics[0]->avg_ball_possession_percentage_opt);
		EXPECT_EQ(teamSeasonStatistics1.fouls_opt, teamSeasonStatistics[0]->fouls_opt);
		EXPECT_EQ(teamSeasonStatistics1.avg_fouls_per_game_opt, teamSeasonStatistics[0]->avg_fouls_per_game_opt);
		EXPECT_EQ(teamSeasonStatistics1.offsides_opt, teamSeasonStatistics[0]->offsides_opt);
		EXPECT_EQ(teamSeasonStatistics1.redcards_opt, teamSeasonStatistics[0]->redcards_opt);
		EXPECT_EQ(teamSeasonStatistics1.yellowcards_opt, teamSeasonStatistics[0]->yellowcards_opt);
		EXPECT_EQ(teamSeasonStatistics1.shots_blocked_opt, teamSeasonStatistics[0]->shots_blocked_opt);
		EXPECT_EQ(teamSeasonStatistics1.shots_off_target_opt, teamSeasonStatistics[0]->shots_off_target_opt);
		EXPECT_EQ(teamSeasonStatistics1.avg_shots_off_target_per_game_opt, teamSeasonStatistics[0]->avg_shots_off_target_per_game_opt);
		EXPECT_EQ(teamSeasonStatistics1.shots_on_target_opt, teamSeasonStatistics[0]->shots_on_target_opt);
		EXPECT_EQ(teamSeasonStatistics1.avg_shots_on_target_per_game_opt, teamSeasonStatistics[0]->avg_shots_on_target_per_game_opt);
		EXPECT_EQ(teamSeasonStatistics1.avg_corners_opt, teamSeasonStatistics[0]->avg_corners_opt);
		EXPECT_EQ(teamSeasonStatistics1.total_corners_opt, teamSeasonStatistics[0]->total_corners_opt);
		EXPECT_EQ(teamSeasonStatistics1.btts_opt, teamSeasonStatistics[0]->btts_opt);
		

		EXPECT_NE(0, teamSeasonStatistics[1]->id);
		EXPECT_EQ(teamSeasonStatistics2.sm_team_id, teamSeasonStatistics[1]->sm_team_id);
		EXPECT_EQ(teamSeasonStatistics2.sm_season_id, teamSeasonStatistics[1]->sm_season_id);
		EXPECT_EQ(teamSeasonStatistics2.sm_stage_id, teamSeasonStatistics[1]->sm_stage_id);
		EXPECT_EQ(teamSeasonStatistics2.home_wins, teamSeasonStatistics[1]->home_wins);
		EXPECT_EQ(teamSeasonStatistics2.away_wins, teamSeasonStatistics[1]->away_wins);
		EXPECT_EQ(teamSeasonStatistics2.home_draws, teamSeasonStatistics[1]->home_draws);
		EXPECT_EQ(teamSeasonStatistics2.away_draws, teamSeasonStatistics[1]->away_draws);
		EXPECT_EQ(teamSeasonStatistics2.home_losses, teamSeasonStatistics[1]->home_losses);
		EXPECT_EQ(teamSeasonStatistics2.away_losses, teamSeasonStatistics[1]->away_losses);
		EXPECT_EQ(teamSeasonStatistics2.home_goals_for, teamSeasonStatistics[1]->home_goals_for);
		EXPECT_EQ(teamSeasonStatistics2.away_goals_for, teamSeasonStatistics[1]->away_goals_for);
		EXPECT_EQ(teamSeasonStatistics2.home_goals_against, teamSeasonStatistics[1]->home_goals_against);
		EXPECT_EQ(teamSeasonStatistics2.away_goals_against, teamSeasonStatistics[1]->away_goals_against);
		EXPECT_EQ(teamSeasonStatistics2.home_clean_sheet, teamSeasonStatistics[1]->home_clean_sheet);
		EXPECT_EQ(teamSeasonStatistics2.away_clean_sheet, teamSeasonStatistics[1]->away_clean_sheet);
		EXPECT_EQ(teamSeasonStatistics2.home_failed_to_score, teamSeasonStatistics[1]->home_failed_to_score);
		EXPECT_EQ(teamSeasonStatistics2.away_failed_to_score, teamSeasonStatistics[1]->away_failed_to_score);
		EXPECT_EQ(teamSeasonStatistics2.home_avg_goals_per_game_scored_opt, teamSeasonStatistics[1]->home_avg_goals_per_game_scored_opt);
		EXPECT_EQ(teamSeasonStatistics2.away_avg_goals_per_game_scored_opt, teamSeasonStatistics[1]->away_avg_goals_per_game_scored_opt);
		EXPECT_EQ(teamSeasonStatistics2.home_avg_goals_per_game_conceded_opt, teamSeasonStatistics[1]->home_avg_goals_per_game_conceded_opt);
		EXPECT_EQ(teamSeasonStatistics2.away_avg_goals_per_game_conceded_opt, teamSeasonStatistics[1]->away_avg_goals_per_game_conceded_opt);
		EXPECT_EQ(teamSeasonStatistics2.home_avg_first_goal_scored, teamSeasonStatistics[1]->home_avg_first_goal_scored);
		EXPECT_EQ(teamSeasonStatistics2.away_avg_first_goal_scored, teamSeasonStatistics[1]->away_avg_first_goal_scored);
		EXPECT_EQ(teamSeasonStatistics2.overall_avg_first_goal_scored, teamSeasonStatistics[1]->overall_avg_first_goal_scored);
		EXPECT_EQ(teamSeasonStatistics2.home_avg_first_goal_conceded, teamSeasonStatistics[1]->home_avg_first_goal_conceded);
		EXPECT_EQ(teamSeasonStatistics2.away_avg_first_goal_conceded, teamSeasonStatistics[1]->away_avg_first_goal_conceded);
		EXPECT_EQ(teamSeasonStatistics2.overall_avg_first_goal_conceded, teamSeasonStatistics[1]->overall_avg_first_goal_conceded);
		EXPECT_EQ(teamSeasonStatistics2.attacks_opt, teamSeasonStatistics[1]->attacks_opt);
		EXPECT_EQ(teamSeasonStatistics2.dangerous_attacks_opt, teamSeasonStatistics[1]->dangerous_attacks_opt);
		EXPECT_EQ(teamSeasonStatistics2.avg_ball_possession_percentage_opt, teamSeasonStatistics[1]->avg_ball_possession_percentage_opt);
		EXPECT_EQ(teamSeasonStatistics2.fouls_opt, teamSeasonStatistics[1]->fouls_opt);
		EXPECT_EQ(teamSeasonStatistics2.avg_fouls_per_game_opt, teamSeasonStatistics[1]->avg_fouls_per_game_opt);
		EXPECT_EQ(teamSeasonStatistics2.offsides_opt, teamSeasonStatistics[1]->offsides_opt);
		EXPECT_EQ(teamSeasonStatistics2.redcards_opt, teamSeasonStatistics[1]->redcards_opt);
		EXPECT_EQ(teamSeasonStatistics2.yellowcards_opt, teamSeasonStatistics[1]->yellowcards_opt);
		EXPECT_EQ(teamSeasonStatistics2.shots_blocked_opt, teamSeasonStatistics[1]->shots_blocked_opt);
		EXPECT_EQ(teamSeasonStatistics2.shots_off_target_opt, teamSeasonStatistics[1]->shots_off_target_opt);
		EXPECT_EQ(teamSeasonStatistics2.avg_shots_off_target_per_game_opt, teamSeasonStatistics[1]->avg_shots_off_target_per_game_opt);
		EXPECT_EQ(teamSeasonStatistics2.shots_on_target_opt, teamSeasonStatistics[1]->shots_on_target_opt);
		EXPECT_EQ(teamSeasonStatistics2.avg_shots_on_target_per_game_opt, teamSeasonStatistics[1]->avg_shots_on_target_per_game_opt);
		EXPECT_EQ(teamSeasonStatistics2.avg_corners_opt, teamSeasonStatistics[1]->avg_corners_opt);
		EXPECT_EQ(teamSeasonStatistics2.total_corners_opt, teamSeasonStatistics[1]->total_corners_opt);
		EXPECT_EQ(teamSeasonStatistics2.btts_opt, teamSeasonStatistics[1]->btts_opt);
		

		EXPECT_NE(0, teamSeasonStatistics[2]->id);
		EXPECT_EQ(teamSeasonStatistics3.sm_team_id, teamSeasonStatistics[2]->sm_team_id);
		EXPECT_EQ(teamSeasonStatistics3.sm_season_id, teamSeasonStatistics[2]->sm_season_id);
		EXPECT_EQ(teamSeasonStatistics3.sm_stage_id, teamSeasonStatistics[2]->sm_stage_id);
		EXPECT_EQ(teamSeasonStatistics3.home_wins, teamSeasonStatistics[2]->home_wins);
		EXPECT_EQ(teamSeasonStatistics3.away_wins, teamSeasonStatistics[2]->away_wins);
		EXPECT_EQ(teamSeasonStatistics3.home_draws, teamSeasonStatistics[2]->home_draws);
		EXPECT_EQ(teamSeasonStatistics3.away_draws, teamSeasonStatistics[2]->away_draws);
		EXPECT_EQ(teamSeasonStatistics3.home_losses, teamSeasonStatistics[2]->home_losses);
		EXPECT_EQ(teamSeasonStatistics3.away_losses, teamSeasonStatistics[2]->away_losses);
		EXPECT_EQ(teamSeasonStatistics3.home_goals_for, teamSeasonStatistics[2]->home_goals_for);
		EXPECT_EQ(teamSeasonStatistics3.away_goals_for, teamSeasonStatistics[2]->away_goals_for);
		EXPECT_EQ(teamSeasonStatistics3.home_goals_against, teamSeasonStatistics[2]->home_goals_against);
		EXPECT_EQ(teamSeasonStatistics3.away_goals_against, teamSeasonStatistics[2]->away_goals_against);
		EXPECT_EQ(teamSeasonStatistics3.home_clean_sheet, teamSeasonStatistics[2]->home_clean_sheet);
		EXPECT_EQ(teamSeasonStatistics3.away_clean_sheet, teamSeasonStatistics[2]->away_clean_sheet);
		EXPECT_EQ(teamSeasonStatistics3.home_failed_to_score, teamSeasonStatistics[2]->home_failed_to_score);
		EXPECT_EQ(teamSeasonStatistics3.away_failed_to_score, teamSeasonStatistics[2]->away_failed_to_score);
		EXPECT_EQ(teamSeasonStatistics3.home_avg_goals_per_game_scored_opt, teamSeasonStatistics[2]->home_avg_goals_per_game_scored_opt);
		EXPECT_EQ(teamSeasonStatistics3.away_avg_goals_per_game_scored_opt, teamSeasonStatistics[2]->away_avg_goals_per_game_scored_opt);
		EXPECT_EQ(teamSeasonStatistics3.home_avg_goals_per_game_conceded_opt, teamSeasonStatistics[2]->home_avg_goals_per_game_conceded_opt);
		EXPECT_EQ(teamSeasonStatistics3.away_avg_goals_per_game_conceded_opt, teamSeasonStatistics[2]->away_avg_goals_per_game_conceded_opt);
		EXPECT_EQ(teamSeasonStatistics3.home_avg_first_goal_scored, teamSeasonStatistics[2]->home_avg_first_goal_scored);
		EXPECT_EQ(teamSeasonStatistics3.away_avg_first_goal_scored, teamSeasonStatistics[2]->away_avg_first_goal_scored);
		EXPECT_EQ(teamSeasonStatistics3.overall_avg_first_goal_scored, teamSeasonStatistics[2]->overall_avg_first_goal_scored);
		EXPECT_EQ(teamSeasonStatistics3.home_avg_first_goal_conceded, teamSeasonStatistics[2]->home_avg_first_goal_conceded);
		EXPECT_EQ(teamSeasonStatistics3.away_avg_first_goal_conceded, teamSeasonStatistics[2]->away_avg_first_goal_conceded);
		EXPECT_EQ(teamSeasonStatistics3.overall_avg_first_goal_conceded, teamSeasonStatistics[2]->overall_avg_first_goal_conceded);
		EXPECT_EQ(teamSeasonStatistics3.attacks_opt, teamSeasonStatistics[2]->attacks_opt);
		EXPECT_EQ(teamSeasonStatistics3.dangerous_attacks_opt, teamSeasonStatistics[2]->dangerous_attacks_opt);
		EXPECT_EQ(teamSeasonStatistics3.avg_ball_possession_percentage_opt, teamSeasonStatistics[2]->avg_ball_possession_percentage_opt);
		EXPECT_EQ(teamSeasonStatistics3.fouls_opt, teamSeasonStatistics[2]->fouls_opt);
		EXPECT_EQ(teamSeasonStatistics3.avg_fouls_per_game_opt, teamSeasonStatistics[2]->avg_fouls_per_game_opt);
		EXPECT_EQ(teamSeasonStatistics3.offsides_opt, teamSeasonStatistics[2]->offsides_opt);
		EXPECT_EQ(teamSeasonStatistics3.redcards_opt, teamSeasonStatistics[2]->redcards_opt);
		EXPECT_EQ(teamSeasonStatistics3.yellowcards_opt, teamSeasonStatistics[2]->yellowcards_opt);
		EXPECT_EQ(teamSeasonStatistics3.shots_blocked_opt, teamSeasonStatistics[2]->shots_blocked_opt);
		EXPECT_EQ(teamSeasonStatistics3.shots_off_target_opt, teamSeasonStatistics[2]->shots_off_target_opt);
		EXPECT_EQ(teamSeasonStatistics3.avg_shots_off_target_per_game_opt, teamSeasonStatistics[2]->avg_shots_off_target_per_game_opt);
		EXPECT_EQ(teamSeasonStatistics3.shots_on_target_opt, teamSeasonStatistics[2]->shots_on_target_opt);
		EXPECT_EQ(teamSeasonStatistics3.avg_shots_on_target_per_game_opt, teamSeasonStatistics[2]->avg_shots_on_target_per_game_opt);
		EXPECT_EQ(teamSeasonStatistics3.avg_corners_opt, teamSeasonStatistics[2]->avg_corners_opt);
		EXPECT_EQ(teamSeasonStatistics3.total_corners_opt, teamSeasonStatistics[2]->total_corners_opt);
		EXPECT_EQ(teamSeasonStatistics3.btts_opt, teamSeasonStatistics[2]->btts_opt);
		
	}
}